@echo off
rem August 8, 2008
rem wakepup2 0.2 (C) 2006, Paul Akterstam ('pakt' on Puppy Linux Forum)
rem Boot diskette for Puppy 2.xx series. For Puppy 1.xx series, use wakepup
rem This version for IDE/USB drives (built-in or external CD-ROM, HD and flash)
rem Inspired by Barry Kauler's BOOT2PUP (http://www.puppyos.com)
rem Except for the drivers, uses only GPL'd software or freeware
rem Requires FreeDOS & FreeCOM

rem additional drivers and menu system added by John Doe with help from Philh, PaulBx1, Crash, jonyo, big pc man and BK during Summer '07
rem DOS reference http://www.csulb.edu/~murdock/dosindex.html

rem This program is distributed in the hope that it will be useful, but
rem WITHOUT ANY WARRANTY; without even the implied warranty of
rem MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
rem General Public License for more details.

rem The GNU General Public License is available from http://www.fsf.org/
rem or, write to the Free Software Foundation, Inc., 59 Temple Place,
rem Suite 330, Boston, MA 02111 USA

echo.
echo   ***  wakepup2 0.3 by pakt - Boot Puppy2 Linux from IDE/USB drives  ***
rem Pause here so USB driver messages can be read...
echo Pausing for driver messages. Press any key to continue or Ctrl-C to abort...
pause >NUL

rem Init
cls
set drv=
set drv1=
set drv2=
set drv3=
set drv4=
set fflg1=
set fflg2=
set usrinput=
set usrinput2=

rem Using SHSUCDX.COM 3.03, a freeware replacement for MSCDEX.EXE
rem Assign 1st IDE-CD to drive X:, 2nd (if found) to drive Y: and USB-CD to drive Z:
driver\SHSUCDX /D:?PCM-CD,W,,1 /D:?IDE-CD,X,,2 /d:?USB-CD,Z,,1 /QQ

goto try_ide

:setSubDirectory

set drv=
set drv1=
set drv2=
set drv3=
set drv4=
set fflg1=
set fflg2=
set usrinput=
set usrinput2=

cls

echo *********************************************************************
echo *                     Select Puppy2 SubDirectory                    *
echo *********************************************************************
echo *                                                                   *
echo *    Please enter the subdirectory path to load Puppy from.         *
echo *    Location must contain marker file(IDEHD, USBHD, or USBFLASH)   *
echo *    Do not enter trailing slash, example:                          *
echo *                                                                   *
echo *    Puppy301                                                       *
echo *                                                                   *
echo *    Press [enter] when you are finished.                           *
echo *                                                                   *
echo *********************************************************************

set /P usrinput2=
set usrinput=%usrinput2%\
echo You entered: "%usrinput2%"

echo Press any key to continue or Ctrl-C to abort...
pause >NUL
cls
goto try_ide

:try_ide
echo Checking any IDE drive for marker file IDEHD...
for %%x in ( C D E F G H I J K L M N O P Q R S T U V ) do if exist %%x:\%usrinput%idehd set drv1=%%x:\%usrinput%
if "%drv1%"=="" goto try_usbhd
echo Found marker file on IDEHD
set drv=%drv1%
set media=idehd
set fflg1=1
goto try_usbhd

:try_usbhd
echo.
echo Checking any USB drive for marker file USBHD...
for %%x in ( C D E F G H I J K L M N O P Q R S T U V ) do if exist %%x:\%usrinput%usbhd set drv2=%%x:\%usrinput%
if "%drv2%"=="" goto try_usbflash
echo Found marker file on USBHD
set drv=%drv2%
set media=usbhd
if "%fflg1%"=="1" set fflg2=1
set fflg1=1
goto try_usbflash

:try_usbflash
echo.
echo Checking any USB drive for marker file USBFLASH...
for %%x in ( C D E F G H I J K L M N O P Q R S T U V ) do if exist %%x:\%usrinput%usbflash set drv3=%%x:\%usrinput%
if "%drv3%"=="" goto try_cd
echo Found marker file on USB
set drv=%drv3%
set media=usbflash
if "%fflg1%"=="1" set fflg2=1
set fflg1=1
goto try_cd

:try_cd
echo.
echo Checking IDE or USB CD-ROM drive for file INITRD.GZ...
for %%x in ( W X Y Z ) do if exist %%x:\%usrinput%initrd.gz set drv4=%%x:\
if "%drv4%"=="" goto done_try
echo Found marker file on IDE or USB CD-ROM drive
set drv=%drv4%
if "%drv%"=="W:\" set media=idecd
if "%drv%"=="X:\" set media=idecd
if "%drv%"=="Y:\" set media=idecd
if "%drv%"=="Z:\" set media=usbcd
if "%fflg1%"=="1" set fflg2=1
set fflg1=1
goto done_try

:done_try
if "%fflg1%"=="" goto failed
if "%fflg2%"=="" goto optmenu

rem found multiple media

echo.
if NOT "%drv1%"=="" echo ...file found on ide, drive %drv1%
if NOT "%drv2%"=="" echo ...file found on usbhd, drive %drv2%
if NOT "%drv3%"=="" echo ...file found on usbflash, drive %drv3%
if NOT "%drv4%"=="" echo ...file found on %media%, drive %drv4%

echo.
echo *************************************************
echo *             Select Boot Media                 *
echo *************************************************
if NOT "%drv1%"=="" echo *  1. ide                                       *
if NOT "%drv2%"=="" echo *  2. usbhd                                     *
if NOT "%drv3%"=="" echo *  3. usbflash                                  *
if NOT "%drv4%"=="" echo *  4. %media%                                     *
echo *************************************************
echo.
choice /C:1234 Please choose :

if "%errorlevel%"=="1" goto e1
if "%errorlevel%"=="2" goto e2
if "%errorlevel%"=="3" goto e3
if "%errorlevel%"=="4" goto e4

:e1
if "%drv1%"=="" goto wrong
set drv=%drv1%
set media=idehd
goto optmenu

:e2
if "%drv2%"=="" goto wrong
set drv=%drv2%
set media=usbhd
goto optmenu

:e3
if "%drv3%"=="" goto wrong
set drv=%drv3%
set media=usbflash
goto optmenu

:e4
if "%drv4%"=="" goto wrong
goto optmenu

:wrong
echo Please select one of the available choices
echo Press any key to continue or Ctrl-C to abort...
pause >NUL
cls
goto done_try


:optmenu

cls

set pfix=
set acpi=
set vga=
set apm=
set noapic=
set ide=
set nopcmcia=
set loglevel=
set nosmp=

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                     Select Puppy2 Boot Mode                       *
echo *********************************************************************
echo *  1. Normal       Normal Boot                                      *
echo *                                                                   *
echo *  2. Ram/NoX      Normal Boot with pfix=ram,nox                    *
echo *                                                                   *
echo *  3. Custom       Set custom boot options                          *
echo *                                                                   *
echo *  4. Failsafe     For when all else fails (type xwin at prompt)    *
echo *                                                                   *
echo *  5. Failsafe2    For laptops, same as above but includes nopcmcia *
echo *                                                                   *
echo *  6. Boot Media   Change the boot media for Puppy (ide,usb,cd,hd)  *
echo *                                                                   *
echo *  7. SubDirectory Change the directory for Puppy                   *
echo *                                                                   *
echo *  8. Floppy File  Executes last saved boot config from floppy      *
echo *                                                                   *
echo *  9. Target File  Executes last saved boot config from target media*
echo *********************************************************************
echo.
choice /C:123456789 Please choose :
if "%errorlevel%"=="1" goto writeoptions
if "%errorlevel%"=="2" set pfix=pfix=ram,nox
if "%errorlevel%"=="2" goto writeoptions
if "%errorlevel%"=="3" goto optmenu2
if "%errorlevel%"=="4" set pfix=pfix=ram,nox,debug
if "%errorlevel%"=="4" set acpi=acpi=off
if "%errorlevel%"=="4" set vga=vga=normal
if "%errorlevel%"=="4" set apm=apm=off
if "%errorlevel%"=="4" set noapic=noapic
if "%errorlevel%"=="4" set ide=ide=nodma
if "%errorlevel%"=="4" goto writeoptions
if "%errorlevel%"=="5" set pfix=pfix=ram,nox,debug
if "%errorlevel%"=="5" set acpi=acpi=off
if "%errorlevel%"=="5" set vga=vga=normal
if "%errorlevel%"=="5" set apm=apm=off
if "%errorlevel%"=="5" set noapic=noapic
if "%errorlevel%"=="5" set ide=ide=nodma
if "%errorlevel%"=="5" set nopcmcia=nopcmcia
if "%errorlevel%"=="5" goto writeoptions
if "%errorlevel%"=="6" goto optmenu1
if "%errorlevel%"=="7" goto setSubDirectory
if "%errorlevel%"=="8" goto load
if "%errorlevel%"=="9" goto load2

:optmenu1

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                 Select Puppy2 Media Location                      *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal           PMEDIA=%media% on Drive %drv% (autodetected)   *
echo *                                                                   *
echo *  2. IDE HD           IDE Harddrive                                *
echo *                                                                   *
echo *  3. USB HD           USB Harddrive                                *
echo *                                                                   *
echo *  4. USB FLASH        USB Flash Media Device or Thumbdrive         *
echo *                                                                   *
echo *  5. CD Drive         IDE or USB CD-ROM                            *
echo *                                                                   *
echo *  6. SubDirectory     Change the directory for Puppy               *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:123456 Please choose :
if "%errorlevel%"=="1" goto optmenu
if "%errorlevel%"=="2" set drv=
if "%errorlevel%"=="2" goto try_ide
if "%errorlevel%"=="3" set drv=
if "%errorlevel%"=="3" goto try_usbhd
if "%errorlevel%"=="4" set drv=
if "%errorlevel%"=="4" goto try_usbflash
if "%errorlevel%"=="5" set drv=
if "%errorlevel%"=="5" goto try_cd
if "%errorlevel%"=="6" set drv=
if "%errorlevel%"=="6" goto setSubDirectory

goto optmenu

:optmenu2

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                 Select Puppy2 acpi Boot Option                    *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal       No acpi switch                                   *
echo *                                                                   *
echo *  2. acpi=on      Default for newer PCs (made 2002 or later)       *
echo *                                                                   *
echo *  3. acpi=off     For older PCs, or use if acpi=on causes problems *
echo *                                                                   *
echo *  4. acpi=force   Needed to force acpi=on on older PCs             *
echo *                                                                   *
echo *  5. acpi=noirq   Disable acpi for irq                             *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12345 Please choose :
if "%errorlevel%"=="1" set acpi=
if "%errorlevel%"=="2" set acpi=acpi=on
if "%errorlevel%"=="3" set acpi=acpi=off
if "%errorlevel%"=="4" set acpi=acpi=force
if "%errorlevel%"=="5" set acpi=acpi=noirq

:optmenu3

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                 Select Puppy2 apm Boot Option                     *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal       No apm switch                                    *
echo *                                                                   *
echo *  2. apm=on       Allow apm power managment                        *
echo *                                                                   *
echo *  3. apm=off      Disable apm power managment                      *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:123 Please choose :
if "%errorlevel%"=="1" set apm=
if "%errorlevel%"=="2" set apm=apm=on
if "%errorlevel%"=="3" set apm=apm=off

:optmenu4

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                 Select Puppy2 noapic Boot Option                  *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal       No noapic switch                                 *
echo *                                                                   *
echo *  2. noapic       Add noapic switch                                *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12 Please choose :
if "%errorlevel%"=="1" set noapic=
if "%errorlevel%"=="2" set noapic=noapic

:optmenu5

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                Select Puppy2 nopcmcia Boot Option                 *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal       Load pcmcia drivers                              *
echo *                                                                   *
echo *  2. nopcmcia     Do not load pcmcia drivers (nopcmcia switch)     *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12 Please choose :
if "%errorlevel%"=="1" set nopcmcia=
if "%errorlevel%"=="2" set nopcmcia=nopcmcia

:optmenu6

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                  Select Puppy2 dma Boot Option                    *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal       No ide dma switch                                *
echo *                                                                   *
echo *  2. ide=nodma    May be needed for booting from CompactFlash      *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12 Please choose :
if "%errorlevel%"=="1" set ide=
if "%errorlevel%"=="2" set ide=ide=nodma

rem vga switch doesn't seem to work with puppy
rem :optmenu7
rem echo ...file found on %media%, drive %drv%
rem echo.
rem echo *********************************************************************
rem echo *                   Select Puppy2 vga Boot Option                   *
rem echo *********************************************************************
rem echo *                                                                   *
rem echo *  1. Normal       No vga switch                                    *
rem echo *                                                                   *
rem echo *  2. vga=normal   Normal (640x480)                                 *
rem echo *                                                                   *
rem echo *  3. vga=791      1024x768                                         *
rem echo *                                                                   *
rem echo *  4. vga=ask      prompt for list of video modes                   *
rem echo *                                                                   *
rem echo *********************************************************************
rem echo.
rem choice /C:1234 Please choose :
rem if "%errorlevel%"=="1" set vga=
rem if "%errorlevel%"=="2" set vga=vga=normal
rem if "%errorlevel%"=="3" set vga=vga=791
rem if "%errorlevel%"=="4" set vga=vga=ask

:optmenu8

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *                 Select Puppy2 pfix Boot Option                    *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal               No pfix switch                           *
echo *                                                                   *
echo *  2. pfix=ram             Skip saved sessions                      *
echo *                                                                   *
echo *  3. pfix=nox             Do not load xserver (type xwin at prompt)*
echo *                                                                   *
echo *  4. pfix=debug           Debug                                    *
echo *                                                                   *
echo *  5. pfix=ram,nox         Both 2 and 3                             *
echo *                                                                   *
echo *  6. pfix=ram,nox,debug   All of 2, 3 and 4                        *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:123456 Please choose :
if "%errorlevel%"=="1" set pfix=
if "%errorlevel%"=="2" set pfix=pfix=ram
if "%errorlevel%"=="3" set pfix=pfix=nox
if "%errorlevel%"=="4" set pfix=pfix=debug
if "%errorlevel%"=="5" set pfix=pfix=ram,nox
if "%errorlevel%"=="6" set pfix=pfix=ram,nox,debug

:optmenu9

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *              Select Puppy2 usbcard Boot Option                    *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal               No pfix=usbcard                          *
echo *                                                                   *
echo *  2. pfix=usbcard         PCMCIA USBCard                           *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12 Please choose :
if "%errorlevel%"=="1" goto optmenu10
if "%errorlevel%"=="2" if not "%pfix%"=="" set pfix=%pfix%,usbcard
if "%errorlevel%"=="2" if "%pfix%"=="" set pfix=pfix=usbcard

:optmenu10

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *               Select Puppy2 loglevel Boot Option                  *
echo *********************************************************************
echo *                                                                   *
echo *  1. No Messages                    loglevel=1                     *
echo *                                                                   *
echo *  2. Some Messages                  loglevel=2                     *
echo *                                                                   *
echo *  3. Puppy Default                  loglevel=3                     *
echo *                                                                   *
echo *  4. Display Warnings               loglevel=4                     *
echo *                                                                   *
echo *  5. Display Events                 loglevel=5                     *
echo *                                                                   *
echo *  6. All Messages                   loglevel=6                     *
echo *                                                                   *
echo *  7. Include Kernel Messages        loglevel=7                     *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:1234567 Please choose :
if "%errorlevel%"=="1" set loglevel=loglevel=1
if "%errorlevel%"=="2" set loglevel=loglevel=2
if "%errorlevel%"=="3" set loglevel=loglevel=3
if "%errorlevel%"=="4" set loglevel=loglevel=4
if "%errorlevel%"=="5" set loglevel=loglevel=5
if "%errorlevel%"=="6" set loglevel=loglevel=6
if "%errorlevel%"=="7" set loglevel=loglevel=7

:optmenu11

cls

echo ...file found on %media%, drive %drv%
echo.
echo *********************************************************************
echo *              Select Puppy2 nosmp Boot Option                      *
echo *********************************************************************
echo *                                                                   *
echo *  1. Normal               No nosmp switch                          *
echo *                                                                   *
echo *  2. nosmp                Add nosmp switch                         *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12 Please choose :
if "%errorlevel%"=="1" goto writeoptions
if "%errorlevel%"=="2" set nosmp=nosmp

:writeoptions

del linld\puppy.lin

echo root=/dev/ram0 >> linld\puppy.lin
echo PMEDIA=%media% >>  linld\puppy.lin
if not "%acpi%"=="" echo %acpi% >> linld\puppy.lin
if not "%pfix%"=="" echo %pfix% >> linld\puppy.lin
if not "%vga%"=="" echo %vga% >> linld\puppy.lin
if not "%apm%"=="" echo %apm% >> linld\puppy.lin
if not "%noapic%"=="" echo %noapic% >> linld\puppy.lin
if not "%ide%"=="" echo %ide% >> linld\puppy.lin
if not "%nopcmcia%"=="" echo %nopcmcia% >> linld\puppy.lin
if not "%loglevel%"=="" echo %loglevel% >> linld\puppy.lin
if not "%usrinput2%"=="" echo psubdir=%usrinput2% >> linld\puppy.lin
if not "%nosmp%"=="" echo %nosmp% >> linld\puppy.lin

:load
LINLD.COM image=%drv%vmlinuz initrd=%drv%initrd.gz cl=@linld\puppy.lin

goto end

:load2
LINLD.COM image=%drv%vmlinuz initrd=%drv%initrd.gz cl=@%drv%\linld\puppy.lin

goto end 

:failed
echo.

:setSubDirMenu
cls
echo ...file not found...
echo.
echo *********************************************************************
echo *              Select Puppy2 SubDirectory path                      *
echo *********************************************************************
echo *                                                                   *
echo *        1. Yes          You will be asked for SubDirectory path    *
echo *                                                                   *
echo *        2. No           Shows additional help for trouble shooting *
echo *                                                                   *
echo *********************************************************************
echo.
choice /C:12 Please choose :
if "%errorlevel%"=="1" goto setSubDirectory

cls
type FAILMSG.TXT

:end
